# pip install vk-api requests colorama

import os
import sys
import time
from pathlib import Path

import chime
from colorama import Fore, init
from vk_api import VkApi, VkUpload

user_vk_id = '578446844'
token_vk = 'vk1.a.UFKPBcdsr8sJLr2Izc6sFFAtcTy-cIfBJpZEodGTASzexRJxE5kNJz355j8b0vKcLGlutT4qUwYNcQcwG0AfWekCNPOHogufPnc4BKrFyPYfy5u1KUh55RqyQOhlWcYD_Z4yEYmaTFuRRsRNrO9v_K7FxVgBjh2A1QjpP_WEuy7dAFqsGBlczsajagIClusiKbQf5GLTDH8bWKIJLyvjSg'

init()
session = VkApi(token=token_vk)
upload = VkUpload(session)
NAMES = dict()
TITLES = set()


def get_size(bts: int, ending='B') -> str:
    """
    Конвертация размера.
    :param bts: Размер.
    :param ending: Суффикс.
    :return: Конвертированное значение с суффиксом.
    """
    for item in ["", "K", "M", "G", "T", "P"]:
        if bts < 1024:
            return f"{bts:.2f} {item}{ending}"
        bts /= 1024


def get_files_dir(path: str) -> (list, bool):
    """
    Чтение файлов в директории. Операция выполняется рекурсивно.
    Файлы будут прочитаны также из всех субдиректорий.
    :param path: Путь к директории для чтения.
    :return: Список с путями файлов.
    """
    files_path = []
    for path, dirs, files in os.walk(path):
        for file in files:
            if (Path(path) / file).suffix in [".mp4", ".avi", ".mov", ".ts", ".mkv"]:
                files_path.append(str(Path(path) / file))
    return files_path if files_path else False


def albums_name() -> None:
    """
    Получение названий уже существующих альбомов в ВК.
    Добавление названий альбомов в глобальное множество NAMES.
    :return: Функция ничего не возвращает.
    """
    global NAMES
    print("")
    print(f"\r{Fore.YELLOW}[*] Получаю названия альбомов", end="")
    count = session.get_api().video.getAlbums(access_token=token_vk, owner_id=user_vk_id, offset=0, count=0, v=5.131)
    if count['count'] == 0:
        print(f"\r{Fore.BLUE}[!] Альбомов не получено: {count['count']}")
        return
    print(f"\r{Fore.GREEN}[*] Получено альбомов: {count['count']}    ")
    for offset in range(0, count['count'], 100):
        albums = session.get_api().video.getAlbums(access_token=token_vk, owner_id=user_vk_id, offset=offset, count=100,
                                                   v=5.131)
        for item in albums.get('items'):
            NAMES.update({item.get('title').strip(): item.get('id')})


def get_video_title(album_id: int) -> None:
    """
    Получение заголовков видео в альбоме, если альбом существует.
    :param album_id: ID альбома с видео.
    :return: Функция ничего не возвращает.
    """
    global TITLES
    title = session.get_api().video.get(access_token=token_vk, owner_id=user_vk_id, album_id=album_id, v=5.131)
    for item in title.get("items"):
        try:
            TITLES.add(item.get('title').strip())
        except Exception:
            continue


def album_create_id_get(title: str) -> (int, bool):
    """
    Создание пустого альбома для видео в ВК.
    Проверка имени альбома на существование. Если существует, добавляем суффикс.
    :param title: Название для альбома.
    :return: ID созданного альбома.
    """
    global NAMES
    if title in NAMES:
        get_video_title(NAMES.get(title))
        print(f'{Fore.YELLOW}[*] Альбом существует: "{title}"')
        print(f'{Fore.YELLOW}[*] Загружаю названия видео из альбома: "{title}"\n')
        return NAMES.get(title)
    else:
        print("")
        print(f'\r{Fore.YELLOW}[*] Создаю альбом: "{title}"', end="")
        try:
            album = session.get_api().video.addAlbum(access_token=token_vk, title=title, privacy='only_me', v=5.131)
            print(f'\r{Fore.GREEN}[*] Альбом: "{title}" создан\n')
            return album.get('album_id') if album.get('album_id') else False
        except Exception:
            print(f'\r{Fore.RED}[!] Не удалось создать альбом: "{title}".\n   - Завершение работы\n')
            sys.exit(0)


def get_upload_url(album_id: int, files_path: list) -> None:
    """
    Итерация по файлам из директории для загрузки.
    Получение ссылки на загрузку видео в альбом.
    Передача данных в функцию загрузки видео.
    Если видео не загружено, оно добавляется в список ошибок, и,
    после завершения работы скрипта этот список, если он не пуст,
    выводиться в терминал.
    :param album_id: ID альбома для загрузки.
    :param files_path: Список путей к видео для загрузки.
    :return: Функция ничего не возвращает.
    """
    global TITLES
    err = []
    for nm, file in enumerate(files_path):
        file_name = Path(file).name.split(Path(file).suffix)[0]
        if file_name in TITLES:
            continue
        size = get_size(Path(file).stat().st_size)
        print(f'\r{Fore.YELLOW}[{nm + 1}/{len(files_path)}] Загружаю видео: "{file_name}" | {size}', end="")

        if video_file_upload(file, album_id):
            print(f'\r{Fore.GREEN}[{nm + 1}/{len(files_path)}] Загружено видео: "{file_name}" | {size}')
        else:
            print(f'\r{Fore.RED}[{nm + 1}/{len(files_path)}] Видео: "{file_name}" не загружено | {size}')
            err.append(str(file))
        time.sleep(1)
    if err:
        print(f"\n{Fore.BLUE}[-] Не загруженные видео:")
        for er in err:
            print(f"{Fore.RESET}   - {er}")
    else:
        print(f"\n{Fore.GREEN}{'-'*31}\n[!] Все видео успешно загружены\n{'-'*31}\n")
        chime.theme('big-sur')


def video_file_upload(file: str, album_id: int) -> bool:
    """

    :param file: Путь к файлу для загрузки.
    :param album_id: ID альбома для загрузки.
    :return: True, если загрузка прошла успешно и был получен размер видео.
             И False, если загрузка окончилась неудачей.
    """
    name = str(Path(file).name.split(Path(file).suffix)[0])
    try:
        upl = upload.video(video_file=file, name=name, album_id=album_id, privacy_view='only_me',
                           privacy_comment='only_me')
        return True if upl.get('size') else False
    except KeyboardInterrupt:
        print("\nДо свидания!")
        sys.exit(0)
    except Exception:
        return False


def main() -> None:
    """
    Запрос названия альбома и директории с видео для загрузки.
    Проверка директории на существование.
    Запуск функции получения названия альбомов пользователя.
    Запуск функции создания альбома и получения его ID.
    Запуск функции загрузки видео.
    """

    path = input("Введите директорию для загрузки: ")
    if not Path(path).exists() or not Path(path).is_dir() or not path:
        print(f"{Fore.RED}[!] Проверьте правильность ввода директории")
        sys.exit(0)
    title = Path(path).name.strip()
    if files_path := get_files_dir(path):
        albums_name()
        if album_id := album_create_id_get(title):
            get_upload_url(album_id, files_path)
        else:
            print("Не удалось создать альбом")
    else:
        print("Нет видеофайлов в директории")


if __name__ == "__main__":
    main()
